/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 4.0.2
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */
package com.herumi.mcl

import kotlin.jvm.JvmOverloads
import com.herumi.mcl.MclJNI
import kotlin.jvm.Synchronized
import com.herumi.mcl.Fp
import com.herumi.mcl.Fr
import com.herumi.mcl.G1
import com.herumi.mcl.G2
import com.herumi.mcl.GT
import com.herumi.mcl.MclConstants
import com.herumi.mcl.SWIGTYPE_p_bool
import com.herumi.mcl.ElgamalJNI
import com.herumi.mcl.CipherText

class G1 protected constructor(
    @field:Transient private var swigCPtr: Long,
    @field:Transient protected var swigCMemOwn: Boolean
) {
    protected fun finalize() {
        delete()
    }

    @Synchronized
    fun delete() {
        if (swigCPtr != 0L) {
            if (swigCMemOwn) {
                swigCMemOwn = false
                MclJNI.delete_G1(swigCPtr)
            }
            swigCPtr = 0
        }
    }

    constructor() : this(MclJNI.new_G1__SWIG_0(), true) {}
    constructor(rhs: G1?) : this(MclJNI.new_G1__SWIG_1(getCPtr(rhs), rhs), true) {}
    constructor(x: Fp?, y: Fp?) : this(
        MclJNI.new_G1__SWIG_2(
            Fp.getCPtr(x),
            x,
            Fp.getCPtr(y),
            y
        ), true
    ) {
    }

    fun equals(rhs: G1?): Boolean {
        return MclJNI.G1_equals(swigCPtr, this, getCPtr(rhs), rhs)
    }

    val isZero: Boolean
        get() = MclJNI.G1_isZero(swigCPtr, this)
    val isValidOrder: Boolean
        get() = MclJNI.G1_isValidOrder(swigCPtr, this)

    operator fun set(x: Fp?, y: Fp?) {
        MclJNI.G1_set(swigCPtr, this, Fp.getCPtr(x), x, Fp.getCPtr(y), y)
    }

    fun clear() {
        MclJNI.G1_clear(swigCPtr, this)
    }

    fun setStr(str: String?, base: Int) {
        MclJNI.G1_setStr__SWIG_0(swigCPtr, this, str, base)
    }

    fun setStr(str: String?) {
        MclJNI.G1_setStr__SWIG_1(swigCPtr, this, str)
    }

    fun toString(base: Int): String? {
        return MclJNI.G1_toString__SWIG_0(swigCPtr, this, base)
    }

    override fun toString(): String {
        return MclJNI.G1_toString__SWIG_1(swigCPtr, this)!!
    }

    fun deserialize(cbuf: ByteArray?) {
        MclJNI.G1_deserialize(swigCPtr, this, cbuf)
    }

    fun serialize(): ByteArray? {
        return MclJNI.G1_serialize(swigCPtr, this)
    }

    fun normalize() {
        MclJNI.G1_normalize(swigCPtr, this)
    }

    fun tryAndIncMapTo(x: Fp?) {
        MclJNI.G1_tryAndIncMapTo(swigCPtr, this, Fp.getCPtr(x), x)
    }

    val x: Fp
        get() = Fp(MclJNI.G1_getX(swigCPtr, this), true)
    val y: Fp
        get() = Fp(MclJNI.G1_getY(swigCPtr, this), true)
    val z: Fp
        get() = Fp(MclJNI.G1_getZ(swigCPtr, this), true)

    companion object {
        fun getCPtr(obj: G1?): Long {
            return obj?.swigCPtr ?: 0
        }
    }
}